/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include <kylin-ai/ai-engine/large-model/aiengine.h>

class BaiduAiEngine : public ai_engine::lm::AbstractAiEnginePluginFactory
{
public:
    ~BaiduAiEngine() = default;
    std::string engineName() const override;
    std::vector<ai_engine::lm::AiCapability> aiCapabilities() const override;
    std::unique_ptr<ai_engine::lm::nlp::AbstractNlpEngine> createNlpEngine() override;
    std::unique_ptr<ai_engine::lm::speech::AbstractSpeechEngine> createSpeechEngine() override;
    std::unique_ptr<ai_engine::lm::vision::AbstractVisionEngine> createVisionEngine() override ;
};
