/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "baidunlpengine.h"

BaiduNlpEngine::BaiduNlpEngine() : d(new BaiduNlpEnginePrivate()) {}

BaiduNlpEngine::~BaiduNlpEngine() { delete d; }

std::string BaiduNlpEngine::engineName() { return d->engineName(); }

void BaiduNlpEngine::setAppId(const std::string &appId) { d->setAppId(appId); }

void BaiduNlpEngine::setApiKey(const std::string &apiKey) {
    d->setApiKey(apiKey);
}

void BaiduNlpEngine::setSecretKey(const std::string &secretKey) {
    d->setSecretKey(secretKey);
}

void BaiduNlpEngine::setChatResultCallback(
    ai_engine::lm::nlp::ChatResultCallback callback) {
    d->setChatResultCallback(callback);
}

void BaiduNlpEngine::setContextSize(int size) { d->setContextSize(size); }

void BaiduNlpEngine::clearContext() { d->clearContext(); }

ai_engine::ErrorCode BaiduNlpEngine::initChatModule() {
    return d->initChatModule();
}

ai_engine::ErrorCode BaiduNlpEngine::chat(const std::string &message) {
    return d->chat(message);
}

void BaiduNlpEngine::stopChat() { d->stopChat(); }

ai_engine::ErrorCode BaiduNlpEngine::destroyChatModule() {
    return d->destroyChatModule();
}
