/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BAIDUNLPENGINE_H
#define BAIDUNLPENGINE_H

#include <kylin-ai/ai-engine/large-model/cloudnlpengine.h>
#include <kylin-ai/plugins/ai-engines/large-model/baidunlpengine_p.h>

class BaiduNlpEnginePrivate;

class BaiduNlpEngine : public ai_engine::lm::nlp::AbstractCloudNlpEngine {
public:
    BaiduNlpEngine();
    ~BaiduNlpEngine();
    std::string engineName() override;

    void setAppId(const std::string &appId) override;
    void setApiKey(const std::string &apiKey) override;
    void setSecretKey(const std::string &secretKey) override;

    void setChatResultCallback(ai_engine::lm::nlp::ChatResultCallback callback) override;

    void setContextSize(int size) override;
    void clearContext() override;

    ai_engine::ErrorCode initChatModule() override;
    ai_engine::ErrorCode chat(const std::string &message) override;
    void stopChat() override;
    ai_engine::ErrorCode destroyChatModule() override;

private:
    BaiduNlpEnginePrivate *d;
};

#endif // BAIDUNLPENGINE_H
