/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include "baiduvisionengine.h"

BaiduVisionEngine::BaiduVisionEngine() : d(new BaiduVisionEnginePrivate()) {}

BaiduVisionEngine::~BaiduVisionEngine() { delete d; }
std::string BaiduVisionEngine::engineName() { return d->engineName(); }

void BaiduVisionEngine::setAppId(const std::string &appId) {
    d->setAppId(appId);
}

void BaiduVisionEngine::setApiKey(const std::string &apiKey) {
    d->setApiKey(apiKey);
}

void BaiduVisionEngine::setSecretKey(const std::string &secretKey) {
    d->setSecretKey(secretKey);
}

void BaiduVisionEngine::setPrompt2ImageCallback(
    ai_engine::lm::vision::ImageResultCallback callback) {
    d->setPrompt2ImageCallback(callback);
}

void BaiduVisionEngine::setPrompt2ImageSize(int width, int height) {
    d->setPrompt2ImageSize(width, height);
}

void BaiduVisionEngine::setPrompt2ImageNumber(int number) {
    d->setPrompt2ImageNumber(number);
}

void BaiduVisionEngine::setPrompt2ImageStyle(int style) {
    d->setPrompt2ImageStyle(style);
}

ai_engine::ErrorCode
BaiduVisionEngine::prompt2Image(const std::string &prompt) {
    return d->prompt2Image(prompt);
}