/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BAIDUVISIONENGINE_H
#define BAIDUVISIONENGINE_H

#include <kylin-ai/ai-engine/large-model/cloudvisionengine.h>
#include <kylin-ai/plugins/ai-engines/large-model/baiduvisionengine_p.h>

class BaiduVisionEngine : public ai_engine::lm::vision::AbstractCloudVisionEngine {
public:
    BaiduVisionEngine();
    ~BaiduVisionEngine();
    std::string engineName() override;

    void setAppId(const std::string &appId) override;
    void setApiKey(const std::string &apiKey) override;
    void setSecretKey(const std::string &secretKey) override;

    void setPrompt2ImageCallback(ai_engine::lm::vision::ImageResultCallback callback) override;
    void setPrompt2ImageSize(int width, int height) override;
    void setPrompt2ImageNumber(int number) override;
    void setPrompt2ImageStyle(int style) override;

    ai_engine::ErrorCode prompt2Image(const std::string &prompt) override;

private:
    BaiduVisionEnginePrivate *d;
};

#endif // BAIDUVISIONENGINE_H
