/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include <assert.h>
#include <iostream>
#include "baidunlpengine.h"

void testNlp() {
    BaiduNlpEngine *engine = new BaiduNlpEngine();

    engine->setAppId("fakeAppId");
    engine->setApiKey("fakeApiKey");
    engine->setSecretKey("fakeSecretKey");
    engine->setChatResultCallback([](const std::string &result) -> void {
        std::cout << result << std::endl;
    });

    auto ret = engine->chat("我叫麒麟软件");
    std::cout << "chat: " << (int)ret << std::endl;
    assert(ret == ai_engine::ErrorCode::Success);

    ret = engine->chat("我是谁");
    std::cout << "chat: " << (int)ret << std::endl;
    assert(ret == ai_engine::ErrorCode::Success);
}

int main(int argc, char *argv[]) {
    testNlp();
    return 0;
}