/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#include <assert.h>
#include <iostream>
#include "baiduvisionengine.h"

void testVision()
{
    BaiduVisionEngine* engine = new BaiduVisionEngine();

    engine->setAppId("fakeAppId");
    engine->setApiKey("fakeApiKey");
    engine->setSecretKey("fakeSecretKey");
    engine->setPrompt2ImageNumber(1);
    engine->setPrompt2ImageCallback([] (ai_engine::lm::vision::ImageData imageData)->void{
        std::cout << "format: " << imageData.format << std::endl;
        std::cout << "height: " << imageData.height << std::endl;
        std::cout << "width: " << imageData.width << std::endl;
        std::cout << "index: " << imageData.index << std::endl;
        std::cout << "total: " << imageData.total << std::endl;
        std::cout << "image data size: " << imageData.imageData.size() << std::endl;
    });

    auto ret = engine->prompt2Image("黄金比例构成，一颗冰晶小苍兰，微距摄影，超详细刻画");
    std::cout << "vision: " << (int)ret << std::endl;
    assert(ret == ai_engine::ErrorCode::Success);
}

int main(int argc, char* argv[])
{
    testVision();
    return 0;
}